100 REM ------------------------------------------------------------
200  REM GW-BASIC Example Program
210  REM For Flash Version 3.0 or greater
300  REM
400  REM This is a sample program intended for reference only. It assumes
500  REM  you have a National Instruments IEEE-488 card and driver loaded.
600  REM The driver device addresses [1..31] are referenced as
700  REM  "DEV1".."DEV31". see the National Instruments Software Ref. Manual
800  REM  for further details.
900  REM
1000  REM Factory default IEEE-488 address for this instrument is 1.
1100  REM
1200  REM You MUST merge this code with DECL.BAS and BIB.M MUST be in this
1300  REM  directory. These files are supplied by National Instruments.
1400 REM ------------------------------------------------------------
1500 REM
1600 REM Test Program for Programmers Command Set Scan and Data Acq Commands
1700 REM IEEE-488 version
1800 REM
1900 REM ------------------------------------------------------------
2000 REM ------------------------------------------------------------
2100     ON ERROR GOTO 35400
2200 REM ------------------------------------------------------------
2300 REM Some Set Up Constants
2400     MONOSTEPSPERUNIT# = 50#
2500 REM ------------------------------------------------------------
2600    PRINT "Begin IEEE-488 Communications Setup"
2700 REM ------------------------------------------------------------
2800 REM     OPEN 
2900 REM
3000    BOARD$ = "GPIB0"
3100    DEVICE$ = "DEV"
3200    RBUF$ = SPACE$(132) : PBUF$ = SPACE$(132)
3300    OBUF$ = SPACE$(132)
3400    JUNK$ = SPACE$(132)
3500    ICH$ = SPACE$(1)
3600    ACK$ = SPACE$(1)
3700    CR$ = CHR$(13) 
3800 REM ..
3900    INPUT "Device Address [1..31]: ",DA$
4000    DA = VAL(DA$)
4100    IF (DA > 0) AND (DA < 32) GOTO 4300
4200    SOUND 350,3 : GOTO 3800
4300 REM ..
4400    DEVICE$ = DEVICE$ + DA$
4500 REM
4600    CALL IBFIND(BOARD$, BD%)
4700    MSG$ = "IBFIND ERROR on " + BOARD$
4800    IF (BD% < 0) THEN GOSUB 39200 : STOP
4900 REM ..
5000    CALL IBFIND(DEVICE$, DV%)
5100    MSG$ = "IBFIND ERROR on " + DEVICE$
5200    IF (DV% < 0) THEN GOSUB 39200 : STOP
5300    EOSV% = &HD
5400    V% = EOSV% + &H1400
5500    CALL IBEOS ( DV%, V% )
5600    CALL IBTMO( DV%, T300MS% )
5700 REM ..
5800 REM     Flush anything in input buffer
5900    CALL IBRD(DV%,JUNK$) : SOUND 2000,1 : PRINT JUNK$
6000    REM     May time out
6100 REM
6200 REM  If we have already autobauded these commands will put us in
6300 REM   a known state without restarting the instrument.
6400 REM
6500    ICH$ = CHR$(222) : CALL IBWRT(DV%,ICH$)
6600    DELAY = .5 : GOSUB 34600       'Wait for possible reset
6700 REM     Flush anything in input buffer
6800    CALL IBRD(DV%,JUNK$) : SOUND 2000,1 : PRINT JUNK$
6900    REM     May time out
7000 REM
7100 REM ..                             'Send <SP>'
7200    ICH$ = " ": CALL IBWRT(DV%, ICH$): SOUND 400, 2
7300    MSG$ = "IBWRT ERROR"
7400    IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
7500 REM
7600    CALL IBRD(DV%, ICH$): SOUND 1000, 2
7700    MSG$ = "IBRD ERROR"
7800    IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
7900 REM
8000    PRINT "Received ", ICH$
8100 REM
8200    IF (ICH$ = "B") GOTO 8700       'BOOT Program ACK O.K.'
8300    IF (ICH$ = "F") GOTO 9900       'MAIN Program ACK O.K.'
8350    IF (ICH$ = "f") GOTO 9900       'MAIN Program ACK O.K. wood v4.0, 4.1'
8400    GOTO 5700                       'Bad Response. Try Again'
8500 REM ..
8600 REM
8700 REM ..    Jump to Main Program
8800    PRINT "Jump to Main Program"
8900    OBUF$ = "O2000" + CHR$(0)
9000    CALL IBWRT(DV%, OBUF$) : MSG$ = "IBWRT ERROR"
9100    IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
9200 REM
9300 REM ..
9400    DELAY = .5 : GOSUB 34600       'Wait for main to start up
9500    CALL IBRD(DV%, ICH$) : MSG$ = "IBRD ERROR"
9600    IF (IBSTA% AND EERR) THEN GOSUB 39200 : RESUME
9700 REM May time out
9800    IF (ICH$ <> "*") GOTO 9300    'Wait for Main Program Response'
9900 REM ..
10000    SOUND 500, 5: SOUND 1000, 5: SOUND 500, 5
10100    PRINT "IEEE-488 Communications Established"
10200    PRINT "Begin IEEE-488 Command Demo"
10300    SAYOK = 1       'ACK sound and OK print out flag'
10400    GOSUB 36100     'Put up the main menu'
10500 REM
10600 REM
10700 REM ------------------------------------------------------------
10800 REM ..     Input Command
10900    PRINT
11000 REM ..
11100    INPUT "Command No:(99 for menu)"; CMDNO
11200    IF (CMDNO = 99) THEN GOSUB 36100 ELSE 11400
11300    GOTO 12000
11400 REM ..
11500    IF (CMDNO = 998) GOTO 38500     'Stop'
11600    IF (CMDNO = 999) GOTO 38500     'Exit'
11700    IF (CMDNO >= MINCMD) AND (CMDNO <= MAXCMD) GOTO 12200
11800    SOUND 700, 5
11900    PRINT "Command Range is"; MINCMD; " to "; MAXCMD
12000 REM
12100    GOTO 11000
12200 REM .. Got a Valid Command
12300    PRINT "Command selected is:"; CMDNO
12400 REM _______________________________________________________
12500    IF (CMDNO = 1) THEN 12600 ELSE 13600
12600 REM ..
12700   INPUT "Move Relative, How much ?", WMONOPOS#
12800   MONOPOS# = WMONOPOS# * MONOSTEPSPERUNIT#
12900   OBUF$ = "F" + "0" + "," + STR$(MONOPOS#) + CR$
13000   CALL IBWRT(DV%, OBUF$) : MSG$ = "IBWRT ERROR"
13100   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
13200 REM
13300   GOSUB 32900             'Wait For Confirmation'
13400    GOTO 10800
13500 REM
13600 REM _______________________________________________________
13700    IF (CMDNO = 2) THEN 13800 ELSE 14900
13800 REM ..
13900    OBUF$ = "C" + "0" + CR$ 
14000    CALL IBWRT( DV%, OBUF$ ) : MSG$ = "IBWRT ERROR"
14100    IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
14200    GOSUB 32900     'Wait For Confirmation'
14300 REM
14400    CALL IBRD( DV%, RBUF$) : SOUND 1000, 2
14500    PBUF$ = LEFT$(RBUF$, INSTR(RBUF$,CR$) - 1)
14600    PRINT "fmin, fmax, ramp_time": PRINT PBUF$
14700    GOTO 10800
14800 REM
14900 REM _______________________________________________________
15000   IF (CMDNO = 3) THEN 15100 ELSE 15900
15100 REM ..
15200    ICH$ = "A" : CALL IBWRT(DV%,ICH$)   'NO comma or <CR> after command'
15300    MSG$ = "IBWRT ERROR"
15400    IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
15500    GOSUB 32900     'Wait For Confirmation'
15600 REM
15700   GOTO 10800
15800 REM
15900 REM _______________________________________________________
16000   IF (CMDNO = 4) THEN 16100 ELSE 18400
16100 REM ..
16200   ICH$ = "y" : CALL IBWRT(DV%, ICH$)   'NO comma or <CR> after command'
16300   MSG$ = "IBWRT ERROR"
16400   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
16500   GOSUB 32900     'Wait For Confirmation'
16600 REM
16700   CALL IBRD(DV%, RBUF$) : MSG$ = "IBRD ERROR"
16800   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
16900 REM
17000   PBUF$ = LEFT$(RBUF$, INSTR(RBUF$,CR$) - 1)
17100   PRINT "BOOT Version:", PBUF$
17200 REM
17300   ICH$ = "z" : CALL IBWRT(DV%, ICH$) : MSG$ = "IBWRT ERROR"
17400   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
17500 REM
17600   GOSUB 32900     'Wait For Confirmation'
17700   CALL IBRD(DV%, RBUF$) : MSG$ = "IBRD ERROR"
17800   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
17900 REM
18000   PBUF$ = LEFT$(RBUF$, INSTR(RBUF$,CR$) - 1)
18100   PRINT "FLASH Version:", PBUF$
18200   GOTO 10800
18300 REM
18400 REM _______________________________________________________
18500   IF (CMDNO = 5) THEN 18600 ELSE 19600
18600 REM ..
18700   INPUT "fmin, fmax, ramp_time"; FREQMIN$, FREQMAX$, RAMPTIME$
18800   OBUF$ = "B"+"0"+"," + FREQMIN$ + "," + FREQMAX$ + "," + RAMPTIME$+CR$
18900   CALL IBWRT(DV%, OBUF$) : MSG$ = "IBWRT ERROR"
19000   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
19100 REM
19200   GOSUB 32900     'Wait For Confirmation'
19300 REM
19400   GOTO 10800
19500 REM
19600 REM _______________________________________________________
19700   IF (CMDNO = 6) THEN 19800 ELSE 21000
19800 REM ..
19900   OBUF$ = "p0,"
20000   OBUF$=OBUF$ + "10000,25000,250,500,3,1500,5000,0,0,0,0,0,0,4,0,0,0,0"
20100   OBUF$ = OBUF$ + CR$
20200   CALL IBWRT(DV%, OBUF$) : MSG$ = "IBWRT ERROR"
20300   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
20400 REM
20500   GOSUB 32900     'Wait For Confirmation'
20510   CALL IBRD(DV%, RBUF$) : MSG$ = "IBRD ERROR"
20520   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
20530   PRINT "Error Code =", RBUF$
20600   MAXDATA# = (25000# - 10000#) / 250# + 1#
20700   PRINT "This Scan will produce", MAXDATA#, " points"
20800   GOTO 10800
20900 REM
21000 REM _______________________________________________________
21100   IF (CMDNO = 7) THEN 21200 ELSE 22100
21200 REM ..
21300   PRINT "Start of Scan"
21400   ICH$ = "q" : CALL IBWRT(DV%, ICH$)   'NO comma or <CR> after command'
21500   MSG$ = "IBWRT ERROR"
21600   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
21700 REM
21800   GOSUB 32900     'Wait For Confirmation'
21900   GOTO 10800
22000 REM
22100 REM _______________________________________________________
22200   IF (CMDNO = 8) THEN 22300 ELSE 26300
22300 REM ..
22310 rem Should loop on cycle # also. See "p..." and "s..." commands
22400   PRINT "Start Data Logging"
22500   OPEN "O", #3, "SCANDATA.PRN"
22600   PTNUMBER# = 0#
22700   SAYOK = 0               'Turn of ACK OK during tight loop'
22800 REM ..
22900   ICH$ = "t" : CALL IBWRT(DV%, ICH$)   'NO comma or <CR> after command'
23000   MSG$ = "IBWRT ERROR"
23100   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
23200 REM
23300   GOSUB 32900             'Wait For Confirmation'
23400   CALL IBRD(DV%,RBUF$) : MSG$ = "IBRD ERROR"
23500   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
23600 REM
23700   PBUF$ = LEFT$(RBUF$, INSTR(RBUF$,",") - 1)
23800   INDEX# = VAL(PBUF$)
23810   PBUF$ = MID$(RBUF$, INSTR(RBUF$,",") + 1)
23820   CYCLE# = VAL(PBUF$)
23900   IF (INDEX# > PTNUMBER#) THEN 24000 ELSE 22800
24000   REM ..
24100   PRINT "index:", INDEX#
24200   WHILE (INDEX# > PTNUMBER#)
24300     PTNUMBER# = PTNUMBER# + 1#
24400     OBUF$ = "u" + STR$(PTNUMBER#) + CR$
24500     CALL IBWRT(DV%, OBUF$) : MSG$ = "IBWRT ERROR"
24600     IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
24700     REM
24800     GOSUB 32900     'Wait For Confirmation'
24900     CALL IBRD(DV%,RBUF$) : MSG$ = "IBRD ERROR"
25000     IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
25100     REM
25200     PBUF$ = LEFT$(RBUF$, INSTR(RBUF$,CR$) - 1)
25300     PRINT #3, PTNUMBER#, PBUF$
25400 REM     PRINT "pt#  data  range", PTNUMBER#, pbuf$
25500   WEND
25600   IF (PTNUMBER# = MAXDATA#) THEN 25700 ELSE 22800
25700   REM ..
25800   CLOSE #3
25900   PRINT "End Data Logging"
26000   SAYOK = 1
26100   GOTO 10800
26200 REM
26300 REM _______________________________________________________
26400   IF (CMDNO = 9) THEN 26500 ELSE 27400
26500 REM ..
26600   INPUT "Where are you ?", WMONOPOS#
26700   MONOPOS# = WMONOPOS# * MONOSTEPSPERUNIT#
26800   OBUF$ = "G0," + STR$(MONOPOS#) + CR$
26900   CALL IBWRT(DV%,OBUF$) : MSG$ = "IBWRT ERROR"
27000   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
27100   GOSUB 32900             'Wait For Confirmation'
27200   GOTO 10800
27300 REM
27400 REM _______________________________________________________
27500   IF (CMDNO = 10) THEN 27600 ELSE 29000
27600 REM ..
27700   OBUF$ = "H0" +CR$
27800   CALL IBWRT(DV%,OBUF$) : MSG$ = "IBWRT ERROR"
27900   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
28000   GOSUB 32900             'Wait For Confirmation'
28100   REM
28200   CALL IBRD(DV%,RBUF$) : MSG$ = "IBRD ERROR"
28300   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
28400   PBUF$ = LEFT$(RBUF$, INSTR(RBUF$,CR$) - 1)
28500   MONOPOS# = VAL(PBUF$)
28600   PRINT "Mono Position (steps, wave length)=", MONOPOS#, MONOPOS# / MONOSTEPSPERUNIT#
28700   GOTO 10800
28800 REM
28900 REM _______________________________________________________
29000   IF (CMDNO = 11) THEN 29100 ELSE 30200
29100 REM ..
29200   ICH$ = "r" : CALL IBWRT(DV%, ICH$)   'NO comma or <CR> after command'
29300   MSG$ = "IBWRT ERROR"
29400   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
29500   GOSUB 32900     'Wait For Confirmation'
29600   CALL IBRD(DV%,RBUF$) : MSG$ = "IBRD ERROR"
29700   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
29800   PBUF$ = LEFT$(RBUF$, INSTR(RBUF$,CR$) - 1)
29900   PRINT "Hardware Status: ", PBUF$
30000   GOTO 10800
30100 REM
30200 REM _______________________________________________________
30300   IF (CMDNO = 12) THEN 30400 ELSE 31500
30400   PRINT "Change to Terminal Communications Mode"
30500   ICH$ = "Y" : CALL IBWRT(DV%, ICH$)   'NO comma or <CR> after command'
30600   MSG$ = "IBWRT ERROR"
30700   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
30800   GOSUB 32900     'Wait For Confirmation'
30900 REM
31000   CALL IBLOC(DV%)
31100   PRINT : PRINT "Change Switch to Hand Held Position"
31200   PRINT "  then Hit <.> on Hand Held twice"
31300   GOTO 10800
31400 REM _______________________________________________________
31500   IF (CMDNO = 13) THEN 31600 ELSE 32300
31600   PRINT "IEEE-488 coming ON-Line"
31700   PRINT "RS-232 I/O should be SILENT"
31800   INPUT " and hit any key"; XXX$
31900   GOTO 4900
32000 REM
32100 REM     Flush anything in input buffer
32200   GOTO 10800
32300 REM _______________________________________________________
32400   PRINT "***Command Not Implimented***"
32500 REM _______________________________________________________
32600   GOTO 10800
32700 REM
32800 REM ------------------------------------------------------------
32900 REM .....Input ACK character and test for valid
33000 REM ------------------------------------------------------------
33100   CALL IBRD(DV%, ACK$) : IF (SAYOK = 1) THEN SOUND 1000, 2
33200   MSG$ = "IBRD ERROR"
33300   IF (IBSTA% AND EERR) THEN GOSUB 39200 : STOP
33400   IF (ACK$ = "o") THEN 33500 ELSE 33800
33500   REM ..
33600   IF (SAYOK = 1) THEN PRINT "Receive was O.K."
33700   GOTO 34200
33800 REM ..
33900   IF (ACK$ = "b") THEN PRINT "Receive was bad"
34000   PRINT "Character Received was: "; ASC(ACK$), ACK$
34100   STOP
34200 REM ..
34300   RETURN
34400 REM
34500 REM ------------------------------------------------------------
34600 REM .....Time Delay of delay
34700 REM ------------------------------------------------------------
34800   T0 = TIMER
34900   WHILE ((TIMER - T0) < DELAY)
35000   WEND
35100   RETURN
35200 REM
35300 REM ------------------------------------------------------------
35400 REM .....Error Handler
35500 REM ------------------------------------------------------------
35600   PRINT "***** Error =", ERR, " on line number", ERL
35700   RESUME
35800   RETURN
35900 REM
36000 REM ------------------------------------------------------------
36100 REM .....Main Menu
36200 REM ------------------------------------------------------------
36300   MINCMD = 1: MAXCMD = 13
36400   PRINT : PRINT "Command:"
36500   PRINT "Motor Move Relative       1"
36600   PRINT "Motor Read Speed          2"
36700   PRINT "Motor Init                3"
36800   PRINT "Program Version #         4"
36900   PRINT "Motor Set Speed           5"
37000   PRINT "Set Scan Parameters       6"
37100   PRINT "Start Scan                7"
37200   PRINT "Log Data                  8"
37300   PRINT "Motor Set Position        9"
37400   PRINT "Motor Read Position      10"
37500   PRINT "Hardware Status          11"
37600   PRINT "Go to RS-232             12"
37700   PRINT " (Startup must have been RS-232)"
37800   PRINT "Come back to IEEE-488    13"
37900   PRINT "----------------------------"
38000   PRINT "Command Menu             99"
38100   PRINT "Stop                    998"
38200   PRINT "Exit                    999"
38300   RETURN
38400 REM ------------------------------------------------------------
38500 REM .....EXIT
38600 REM ------------------------------------------------------------
38700   PRINT "End IEEE-488 Command Demo"
38800   CALL IBLOC(DV%)
38900   IF (CMDNO = 998) THEN STOP ELSE SYSTEM
39000 REM ------------------------------------------------------------
39100 REM ------------------------------------------------------------
39200 REM .....IEEE-488 ERROR
39300 REM ------------------------------------------------------------
39400 REM This routine will notify you that an IB call failed and print 
39500 REM the status variables.
39600 REM ------------------------------------------------------------
39700 REM
39800     PRINT MSG$
39900 REM 
40000     PRINT "ibsta= &H"; HEX$(IBSTA%); " <";
40100     IF IBSTA% AND EERR  THEN PRINT " ERR";
40200     IF IBSTA% AND TIMO THEN PRINT " TIMO";
40300     IF IBSTA% AND EEND THEN PRINT " END";
40400     IF IBSTA% AND SRQI THEN PRINT " SRQI";
40500     IF IBSTA% AND RQS  THEN PRINT " RQS";
40600     IF IBSTA% AND CMPL THEN PRINT " CMPL";
40700     IF IBSTA% AND LOK  THEN PRINT " LOK";
40800     IF IBSTA% AND RREM THEN PRINT " REM";
40900     IF IBSTA% AND CIC  THEN PRINT " CIC";
41000     IF IBSTA% AND AATN THEN PRINT " ATN";
41100     IF IBSTA% AND TACS THEN PRINT " TACS";
41200     IF IBSTA% AND LACS THEN PRINT " LACS";
41300     IF IBSTA% AND DTAS THEN PRINT " DTAS";
41400     IF IBSTA% AND DCAS THEN PRINT " DCAS";
41500     PRINT ">"
41600 REM     
41700     PRINT "iberr= "; IBERR%;
41800     IF IBERR% = EDVR THEN PRINT " EDVR <DOS Error>"
41900     IF IBERR% = ECIC THEN PRINT " ECIC <Not CIC>"
42000     IF IBERR% = ENOL THEN PRINT " ENOL <No Listener>"
42100     IF IBERR% = EADR THEN PRINT " EADR <Address error>"
42200     IF IBERR% = EARG THEN PRINT " EARG <Invalid argument>"
42300     IF IBERR% = ESAC THEN PRINT " ESAC <Not Sys Ctrlr>"
42400     IF IBERR% = EABO THEN PRINT " EABO <Op. aborted>"
42500     IF IBERR% = ENEB THEN PRINT " ENEB <No GPIB board>"
42600     IF IBERR% = EOIP THEN PRINT " EOIP <Async I/O in prg>"
42700     IF IBERR% = ECAP THEN PRINT " ECAP <No capability>"
42800     IF IBERR% = EFSO THEN PRINT " EFSO <File sys. error>"
42900     IF IBERR% = EBUS THEN PRINT " EBUS <Command error>"
43000     IF IBERR% = ESTB THEN PRINT " ESTB <Status byte lost>"
43100     IF IBERR% = ESRQ THEN PRINT " ESRQ <SRQ stuck on>"
43200     IF IBERR% = ETAB THEN PRINT " ETAB <Table Overflow>"
43300 REM
43400     PRINT "ibcnt = "; IBCNT% 
43500 REM
43600 REM Call the IBONL function to disable the hardware and software
43700 REM  unless error was a time out.
43800     IF IBSTA% AND TIMO THEN RETURN
43900     V% = 0 : CALL IBONL(BD%, V%) : RETURN
44000 REM
44100     END
