100 REM ------------------------------------------------------------
200  REM GW-BASIC Example Program
300  REM
301  REM
302  REM For Data Scan/Link Flash Version 3.0 or Greater
303  REM
304  REM
400  REM This is a sample program intended for reference only.
500 REM ------------------------------------------------------------
600 REM
700 REM Test Program for Programmers Command Set Scan and Data Acq Commands
800 REM RS-232 version.
900 REM
1000 REM ------------------------------------------------------------
1100 REM ------------------------------------------------------------
1200     ON ERROR GOTO 29000
1300 REM ------------------------------------------------------------
1400 REM Some Set Up Constants for your mono.
1500     MONOSTEPSPERUNIT# = 50#
1600 REM ------------------------------------------------------------
1700    PRINT "Begin RS-232 Communications Setup"
1800 REM ------------------------------------------------------------
1900 REM     Open Com Port 2
2000 REM 4800 baud, no parity, 8 bits, 1 stop, suppress Request to Send
2100 REM
2200    OPEN "com2:4800,N,8,1,RS,DS0" FOR RANDOM AS #2
2300 REM ..
2400 REM     Flush anything in input buffer
2500    DELAY = .5: GOSUB 28200        'Wait a little'
2600    WHILE (LOC(2) > 0)
2700      JUNK$ = INPUT$(1, #2): SOUND 2000, 5
2800    WEND
2900 REM
3000 REM  If we have already autobauded these commands will put us in
3100 REM   a known state without restarting the instrument.
3200    PRINT #2, CHR$(248);            'Send Hi IQ Mode Pseudo Commnad'
3300    PRINT #2, CHR$(222);            'Send Software Reboot if Hung'
3400    DELAY = .5: GOSUB 28200         'Wait a little'
3500    WHILE (LOC(2) > 0)              'Flush input'
3600      JUNK$ = INPUT$(1, #2): SOUND 2000, 5
3700    WEND
3800 REM
3900 REM     Begin Autobaud Sequence
4000 REM ..                             'Send <SP>'
4100    PRINT #2, " "; : SOUND 400, 2
4200    DELAY = .5: GOSUB 28200      'Wait a little'
4300    IF (LOC(2) > 0) THEN 4600 ELSE 4400
4400 REM ..
4500    GOTO 4000                       'No Response. Try Again'
4600    ICH$ = INPUT$(1, #2): SOUND 1000, 2
4700    PRINT "Received ", ICH$
4800    IF (ICH$ = "*") GOTO 5400       'Autobaud ACK O.K.'
4900 REM
5000 REM  If already autobauded, take appropriate action.
5100    IF (ICH$ = "B") GOTO 6400       'BOOT Program ACK O.K.'
5200    IF (ICH$ = "F") GOTO 7100       'MAIN Program ACK O.K.'
5300    GOTO 2300                       'Bad Response. Try Again'
5400 REM ..
5500    DELAY = .5: GOSUB 28200         'Wait a little'
5600    INPUT #2, BOOTMSG$              'Flush out Boot Message'
5700    PRINT BOOTMSG$
5800 REM
5900    PRINT #2, CHR$(247);            'Send UTIL STARTUP INTELLIGENT MODE'
6000 REM
6100    ICH$ = INPUT$(1, #2)            'ACK of UTIL STARTUP INTELLIGENT MODE'
6200    IF (ICH$ <> "=") GOTO 2300      'Bad ACK. Try Again'
6300 REM
6400 REM ..    Jump to Main Program
6500    PRINT "Jump to Main Program"
6600    PRINT #2, "O";                  'Send UTIL START MAIN PROGRAM'
6700    PRINT #2, "2000"; : PRINT #2, CHR$(0);
6800 REM
6900    WHILE (INPUT$(1, #2) <> "*")    'Wait for Main Program Response'
7000    WEND
7100 REM ..
7200    SOUND 500, 5: SOUND 1000, 5: SOUND 500, 5
7300    PRINT "RS-232 Communications Established"
7400    PRINT "Begin RS-232 Command Demo"
7500    SAYOK = 1       'ACK sound and OK print out flag'
7600    GOSUB 29700     'Put up the main menu'
7700 REM
7800 REM
7900 REM ------------------------------------------------------------
8000 REM ..     Input Command
8100    PRINT
8200 REM ..
8300    INPUT "Command No:(99 for menu)"; CMDNO
8400    IF (CMDNO = 99) THEN GOSUB 29700 ELSE 8600
8500    GOTO 9200
8600 REM ..
8700    IF (CMDNO = 998) GOTO 32000     'Stop'
8800    IF (CMDNO = 999) GOTO 32000     'Exit'
8900    IF (CMDNO >= MINCMD) AND (CMDNO <= MAXCMD) GOTO 9400
9000    SOUND 700, 5
9100    PRINT "Command Range is"; MINCMD; " to "; MAXCMD
9200 REM
9300    GOTO 8200
9400 REM .. Got a Valid Command
9500    PRINT "Command selected is:"; CMDNO
9600 REM _______________________________________________________
9700    IF (CMDNO = 1) THEN 9800 ELSE 10700
9800 REM ..
9900   INPUT "Move Relative, How much ?", WMONOPOS#
10000   MONOPOS# = WMONOPOS# * MONOSTEPSPERUNIT#
10100   PRINT #2, "F";
10200   PRINT #2, "0,";
10300   PRINT #2, MONOPOS#
10400   GOSUB 26700             'Wait For Confirmation'
10500    GOTO 8000
10600 REM
10700 REM _______________________________________________________
10800    IF (CMDNO = 2) THEN 10900 ELSE 11800
10900 REM ..
11000    PRINT #2, "C";                  'NO comma or <CR> after command'
11100    PRINT #2, "0"                   'Parameter followed by <CR>'
11200    GOSUB 26700     'Wait For Confirmation'
11300 REM
11400    INPUT #2, FMIN#, FMAX#, RAMPT%: SOUND 1000, 2
11500    PRINT "fmin, fmax, ramp_time": PRINT FMIN#, FMAX#, RAMPT%
11600    GOTO 8000
11700 REM
11800 REM _______________________________________________________
11900   IF (CMDNO = 3) THEN 12000 ELSE 12600
12000 REM ..
12100    PRINT #2, "A";                  'NO comma or <CR> after command'
12200    GOSUB 26700     'Wait For Confirmation'
12300 REM
12400   GOTO 8000
12500 REM
12600 REM _______________________________________________________
12700   IF (CMDNO = 4) THEN 12800 ELSE 14100
12800 REM ..
12900   PRINT #2, "y";                  'NO comma or <CR> after command'
13000   GOSUB 26700     'Wait For Confirmation'
13100 REM
13200   INPUT #2, VERNO$
13300   PRINT "BOOT Version:", VERNO$
13400 REM
13500   PRINT #2, "z";
13600   GOSUB 26700     'Wait For Confirmation'
13700   INPUT #2, VERNO$
13800   PRINT "MAIN Version:", VERNO$
13900   GOTO 8000
14000 REM
14100 REM _______________________________________________________
14200   IF (CMDNO = 5) THEN 14300 ELSE 15600
14300 REM ..
14400   INPUT "fmin, fmax, ramp_time"; FREQMIN$, FREQMAX$, RAMPTIME$
14500   PRINT #2, "B";                  'NO comma or <CR> after command'
14600   PRINT #2, "0,";                 'Build Parameter String'
14700   PRINT #2, FREQMIN$;             ' separated by commas and NO <CR>'
14800   PRINT #2, ",";
14900   PRINT #2, FREQMAX$;
15000   PRINT #2, ",";
15100   PRINT #2, RAMPTIME$             'Last parameter followed by <CR>'
15200   GOSUB 26700     'Wait For Confirmation'
15300 REM
15400   GOTO 8000
15500 REM
15600 REM _______________________________________________________
15700   IF (CMDNO = 6) THEN 15800 ELSE 16700
15800 REM ..
15900   PRINT #2, "p";
16000   PRINT #2, "0,"; 'Scan Type'
16100   PRINT #2, "10000,25000,250,500,3,1500,5000,0,0,0,0,0,0,4,0,0,0,0"
16200   GOSUB 26700     'Wait For Confirmation'
16210   input #2, errcode
16212   print "Error Code =",errcode
16300   MAXDATA# = (25000# - 10000#) / 250# + 1#
16400   PRINT "This Scan will produce", MAXDATA#, " points"
16500   GOTO 8000
16600 REM
16700 REM _______________________________________________________
16800   IF (CMDNO = 7) THEN 16900 ELSE 17500
16900 REM ..
17000   PRINT "Start of Scan"
17100   PRINT #2, "q";
17200   GOSUB 26700     'Wait For Confirmation'
17300   GOTO 8000
17400 REM
17500 REM _______________________________________________________
17600   IF (CMDNO = 8) THEN 17700 ELSE 20900
17700 REM ..
17710 rem Should loop on cycle # also. See "p..." and "s..." commands
17800   PRINT "Start Data Logging"
17900   OPEN "O", #3, "SCANDATA.PRN"
18000   PTNUMBER# = 0# : cycnum# = 0#
18100   SAYOK = 0               'Turn of ACK OK during tight loop'
18200 REM ..
18300   PRINT #2, "t";          'Get point number of last data taken'
18400   GOSUB 26700             'Wait For Confirmation'
18500   INPUT #2, INDEX#, cycle#
18510   if (cycle# = cycnum# ) then 18600 else 18512
18512 rem ..
18514   Print "Cycle Number:",cycle#
18516   cycnum# = cycle#
18600   IF (INDEX# > PTNUMBER#) THEN 18700 ELSE 18200
18700   REM ..
18800   PRINT "index:", INDEX#
18900   WHILE (INDEX# > PTNUMBER#)
19000     PTNUMBER# = PTNUMBER# + 1#
19100     PRINT #2, "u";
19200 REM    DELAY = .05: GOSUB 20900      'Wait a little'
19300 REM    PRINT #2, PTNUMBER#;
19400 REM    DELAY = .05: GOSUB 20900      'Wait a little'
19500 REM    PRINT #2, ""
19600     PRINT #2, PTNUMBER#
19700     GOSUB 26700     'Wait For Confirmation'
19800     INPUT #2, DDATA#, RANGE%
19900     PRINT #3, PTNUMBER#, DDATA#, RANGE%
20000 REM     PRINT "pt#  data  range", PTNUMBER#, DDATA#, RANGE%
20100   WEND
20200   IF (PTNUMBER# = MAXDATA#) THEN 20300 ELSE 18200
20300   REM ..
20400   CLOSE #3
20500   PRINT "End Data Logging"
20600   SAYOK = 1
20700   GOTO 8000
20800 REM
20900 REM _______________________________________________________
21000   IF (CMDNO = 9) THEN 21100 ELSE 22000
21100 REM ..
21200   INPUT "Where are you ?", WMONOPOS#
21300   MONOPOS# = WMONOPOS# * MONOSTEPSPERUNIT#
21400   PRINT #2, "G";
21500   PRINT #2, "0,";
21600   PRINT #2, MONOPOS#
21700   GOSUB 26700             'Wait For Confirmation'
21800   GOTO 8000
21900 REM
22000 REM _______________________________________________________
22100   IF (CMDNO = 10) THEN 22200 ELSE 23200
22200 REM ..
22300   PRINT #2, "H";
22400   PRINT #2, "0"
22500   GOSUB 26700             'Wait For Confirmation'
22600   REM
22700   INPUT #2, MONOPOS#
22800   PRINT "Mono Position (steps, wave length)=", MONOPOS#, MONOPOS# / MONOSTEPSPERUNIT#
22900   GOTO 8000
23000 REM
23100 REM _______________________________________________________
23200   IF (CMDNO = 11) THEN 23300 ELSE 24000
23300 REM ..
23400   PRINT #2, "r";
23500   GOSUB 26700     'Wait For Confirmation'
23600   STATUS$ = INPUT$(1, #2)
23700   PRINT "Hardware Status:", ASC(STATUS$)
23800   GOTO 8000
23900 REM
24000 REM _______________________________________________________
24100   IF (CMDNO = 12) THEN 24200 ELSE 24900
24200   PRINT "Change to Terminal Mode"
24300   PRINT #2, "Y";
24400   GOSUB 26700     'Wait For Confirmation'
24500   PRINT : PRINT "Change Switch to Hand Held Position"
24600   PRINT "  then Hit <.> on Hand Held twice"
24700   GOTO 8000
24800 REM _______________________________________________________
24900   IF (CMDNO = 13) THEN 25000 ELSE 26100
25000   PRINT "Going to Intelligent Communications Mode"
25100   PRINT "Change Switch to Computer Position"
25200   INPUT " and hit any key"; JUNK$
25300   PRINT #2, CHR$(248); 'UTIL Intelligent Communications Pseudo Command'
25400 REM NO CONFIRMATION FOR pseudo Command
25500 REM
25600 REM     Flush anything in input buffer
25700    WHILE (LOC(2) > 0)
25800      JUNK$ = INPUT$(1, #2): SOUND 2000, 1: PRINT JUNK$;
25900    WEND
26000   GOTO 8000
26100 REM _______________________________________________________
26200   PRINT "***Command Not Implimented***"
26300 REM _______________________________________________________
26400   GOTO 8000
26500 REM
26600 REM ------------------------------------------------------------
26700 REM .....Input ACK character and test for valid
26800 REM ------------------------------------------------------------
26900   ACK$ = INPUT$(1, #2): IF (SAYOK = 1) THEN SOUND 1000, 2
27000   IF (ACK$ = "o") THEN 27100 ELSE 27400
27100   REM ..
27200   IF (SAYOK = 1) THEN PRINT "Receive was O.K."
27300   GOTO 27800
27400 REM ..
27500   IF (ACK$ = "b") THEN PRINT "Receive was bad"
27600   PRINT "Character Received was: "; ASC(ACK$), ACK$
27700   STOP
27800 REM ..
27900   RETURN
28000 REM
28100 REM ------------------------------------------------------------
28200 REM .....Time Delay of delay
28300 REM ------------------------------------------------------------
28400   T0 = TIMER
28500   WHILE ((TIMER - T0) < DELAY)
28600   WEND
28700   RETURN
28800 REM
28900 REM ------------------------------------------------------------
29000 REM .....Error Handler
29100 REM ------------------------------------------------------------
29200   PRINT "***** Error =", ERR, " on line number", ERL
29300   RESUME
29400   RETURN
29500 REM
29600 REM ------------------------------------------------------------
29700 REM .....Main Menu
29800 REM ------------------------------------------------------------
29900   MINCMD = 1: MAXCMD = 13
30000   PRINT : PRINT "Command:"
30100   PRINT "Motor Move Relative       1"
30200   PRINT "Motor Read Speed          2"
30300   PRINT "Motor Init                3"
30400   PRINT "Program Version #         4"
30500   PRINT "Motor Set Speed           5"
30600   PRINT "Set Scan Parameters       6"
30700   PRINT "Start Scan                7"
30800   PRINT "Log Data                  8"
30900   PRINT "Motor Set Position        9"
31000   PRINT "Motor Read Position      10"
31100   PRINT "Hardware Status          11"
31200   PRINT "Go to Terminal Mode      12"
31300   PRINT "Go to Computer Mode      13"
31400   PRINT "----------------------------"
31500   PRINT "Command Menu             99"
31600   PRINT "Stop                    998"
31700   PRINT "Exit                    999"
31800   RETURN
31900 REM ------------------------------------------------------------
32000 REM .....EXIT
32100 REM ------------------------------------------------------------
32200   PRINT "End RS-232 Command Demo"
32300   CLOSE #2
32400   IF (CMDNO = 998) THEN STOP ELSE SYSTEM
32500   END

